"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var pinyin_service_1 = require("../pinyin.service");
var AutoCompleteComponent = /** @class */ (function () {
    function AutoCompleteComponent(resolver, router, pinyinService) {
        this.resolver = resolver;
        this.router = router;
        this.pinyinService = pinyinService;
        this.textChangeEvent = new core_1.EventEmitter();
        this.show_source = [];
    }
    AutoCompleteComponent.prototype.ngOnInit = function () {
    };
    AutoCompleteComponent.prototype.ngOnChanges = function (changes) {
    };
    AutoCompleteComponent.prototype.blur = function () {
        this.showContainer = false;
    };
    AutoCompleteComponent.prototype.focus = function () {
        this.changeText();
    };
    AutoCompleteComponent.prototype.press = function (event) {
        if (event.key == 'Tab') {
            event.preventDefault();
            for (var i = 0; i < this.show_source.length; i++) {
                if (this.show_source[i].show) {
                    this.show_source[i].show = false;
                    if (i == this.show_source.length - 1) {
                        this.show_source[0].show = true;
                    }
                    else {
                        this.show_source[i + 1].show = true;
                    }
                    break;
                }
            }
        }
        if (event.key == 'Enter') {
            for (var _i = 0, _a = this.show_source; _i < _a.length; _i++) {
                var _c = _a[_i];
                if (_c.show) {
                    this.text = _c.title;
                }
            }
            this.showContainer = false;
        }
    };
    AutoCompleteComponent.prototype.changeText = function () {
        var _this = this;
        if (this.text == null) {
            this.text = "";
        }
        this.show_source = [];
        var tempSource = this.source.filter(function (item) {
            return item.indexOf(_this.text) >= 0 || _this.pinyinService.toPinyin(item).indexOf(_this.text) >= 0;
        });
        for (var i = 0; i < tempSource.length; i++) {
            var _show = i == 0;
            this.show_source.push({
                title: tempSource[i],
                show: _show
            });
        }
        this.showContainer = true;
    };
    AutoCompleteComponent.prototype.selectText = function (t) {
        this.text = t;
        this.showContainer = false;
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], AutoCompleteComponent.prototype, "source", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], AutoCompleteComponent.prototype, "width", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], AutoCompleteComponent.prototype, "textChangeEvent", void 0);
    AutoCompleteComponent = __decorate([
        core_1.Component({
            selector: 'dc-auto-component',
            template: "\n  <div class=\"display-flex width-100 flex-direction-column\" [style.position]=\"'relative'\" [style.max-width]=\"width\">\n    <input type=\"text\" [(ngModel)]=\"text\" (keydown)=\"press($event)\" (blur)=\"blur()\" (focus)=\"focus()\" (ngModelChange)=\"changeText()\">\n    <div class=\"complete-container width-100 flex-direction-column\" *ngIf=\"showContainer\">\n        <div *ngFor=\"let c of show_source\" class=\"source-title\" [ngClass]=\"{active:c.show}\" (click)=\"selectText(c)\">\n            {{c.title}}\n        </div> \n    </div>\n</div>\n  ",
            styles: [
                '.title.active{color: red}',
                '.title{cursor: pointer;}',
                '.complete-container{position: absolute;top:24px;background-color: wheat;}',
                '.source-title{max-width: 100%;overflow: hidden;text-overflow: ellipsis;cursor: pointer;}',
                '.source-title.active{color: rebeccapurple;}',
            ]
        }),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver, router_1.Router, pinyin_service_1.PinyinService])
    ], AutoCompleteComponent);
    return AutoCompleteComponent;
}());
exports.AutoCompleteComponent = AutoCompleteComponent;
//# sourceMappingURL=auto.component.component.js.map