"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var DrawComponent = /** @class */ (function () {
    function DrawComponent(router, resolver, elementRef, injector, applicationRef) {
        this.router = router;
        this.resolver = resolver;
        this.elementRef = elementRef;
        this.injector = injector;
        this.applicationRef = applicationRef;
        this.show = false;
        this.firstInit = true;
    }
    DrawComponent.prototype.onClick = function (event) {
        var _this = this;
        //第一次点击无效
        if (this.firstInit) {
            this.firstInit = false;
            return;
        }
        if (!this.elementRef.nativeElement.contains(event.target)) {
            var result = this.componentRef.instance.beforeLeave();
            if (typeof (result) == "boolean" && result) {
                this.closeComponent();
            }
            if (typeof (result) == "object" && result.then) {
                result.then(function (r) {
                    if (r) {
                        _this.closeComponent();
                    }
                });
            }
        }
    };
    DrawComponent.prototype.closeComponent = function () {
        var _this = this;
        this.show = false;
        setTimeout(function () {
            _this.container.clear();
            _this.closeResolve('close');
        }, 500);
    };
    DrawComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function () {
            _this.show = true;
        });
    };
    DrawComponent.prototype.ngOnDestroy = function () {
        this.container.clear();
    };
    DrawComponent.prototype.ngDoCheck = function () {
    };
    DrawComponent.prototype.ngOnInit = function () {
        this.container.clear();
        this.componentRef = this.container.createComponent(this.resolver.resolveComponentFactory(this.injectComponet));
        this.instance = this.componentRef.instance;
        this.instance.data = this.data;
    };
    DrawComponent.prototype.ngOnChanges = function (changes) {
    };
    __decorate([
        core_1.ViewChild("componentContainer", { read: core_1.ViewContainerRef }),
        __metadata("design:type", core_1.ViewContainerRef)
    ], DrawComponent.prototype, "container", void 0);
    __decorate([
        core_1.HostListener('document:click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DrawComponent.prototype, "onClick", null);
    DrawComponent = __decorate([
        core_1.Component({
            selector: "drawer",
            template: "\n   <div class=\"draw-container\" [ngClass]=\"{'show':show}\">\n    <ng-template #componentContainer></ng-template>\n   </div>\n  ",
            styles: [
                '.draw-container{' +
                    'width: 66%;' +
                    'position: absolute;' +
                    'height: 100vh;' +
                    'right: 0;' +
                    'background-color: white;' +
                    'max-width: 0;' +
                    'transition: max-width 0.5s ease-in,color 0.3s ease-out;' +
                    'box-shadow: -2px 0px 15px 0px #888888;' +
                    'z-index: 1;' +
                    'background: #fcfcfc;' +
                    'padding: 30px;' +
                    'overflow-x: hidden;' +
                    'overflow-y: auto}',
                '.draw-container.show{max-width:100%;}'
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, core_1.ComponentFactoryResolver,
            core_1.ElementRef, core_1.Injector, core_1.ApplicationRef])
    ], DrawComponent);
    return DrawComponent;
}());
exports.DrawComponent = DrawComponent;
//# sourceMappingURL=draw.component.js.map