"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
var core_1 = require("@angular/core");
var modal_component_1 = require("./modal.component");
var document_ref_service_1 = require("../document-ref/document-ref.service");
var ModalService = /** @class */ (function () {
    function ModalService(cfr, appRef, doc, injector) {
        this.cfr = cfr;
        this.appRef = appRef;
        this.doc = doc;
        this.injector = injector;
    }
    ModalService.prototype.insert = function (viewRef) {
        this.appRef.attachView(viewRef);
        this.doc.body.insertBefore(viewRef.rootNodes[0], this.doc.body.childNodes[0]);
        return viewRef;
    };
    ModalService.prototype.createComponent = function (cf) {
        var componentRef = cf.create(this.injector);
        this.insert(componentRef.hostView);
        return componentRef;
    };
    ModalService.prototype.open = function (_a) {
        var id = _a.id, title = _a.title, component = _a.component, width = _a.width, data = _a.data, handler = _a.handler, backdropCloseable = _a.backdropCloseable, onClose = _a.onClose, beforeHidden = _a.beforeHidden;
        var modalRef = this.createComponent(this.cfr.resolveComponentFactory(modal_component_1.ModalComponent));
        _.assign(modalRef.instance, { id: id, title: title, width: width, beforeHidden: beforeHidden, backdropCloseable: _.isUndefined(backdropCloseable) ? true : backdropCloseable });
        var modalContentInstance = modalRef.instance.modalContainerHost.viewContainerRef.createComponent(this.cfr.resolveComponentFactory(component));
        _.assign(modalContentInstance.instance, { data: data, handler: handler });
        modalRef.instance.onHidden = function () {
            if (onClose) {
                onClose();
            }
            modalRef.hostView.destroy();
        };
        modalRef.instance.show();
        return {
            modalInstance: modalRef.instance,
            modalContentInstance: modalContentInstance.instance
        };
    };
    ModalService = __decorate([
        core_1.Injectable(),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver,
            core_1.ApplicationRef,
            document_ref_service_1.DocumentRef,
            core_1.Injector])
    ], ModalService);
    return ModalService;
}());
exports.ModalService = ModalService;
//# sourceMappingURL=modal.service.js.map