"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var tab_directive_1 = require("./tab.directive");
var TabComponent = /** @class */ (function () {
    function TabComponent(resolver, router, changeRef) {
        this.resolver = resolver;
        this.router = router;
        this.changeRef = changeRef;
        this.tabChangeEvent = new core_1.EventEmitter();
    }
    Object.defineProperty(TabComponent.prototype, "tabDatas", {
        get: function () {
            return this._tabDatas;
        },
        set: function (v) {
            this._tabDatas = v;
        },
        enumerable: true,
        configurable: true
    });
    TabComponent.prototype.ngAfterViewInit = function () {
        this.init();
    };
    TabComponent.prototype.init = function () {
        var _this = this;
        if (this.tabDatas == null && this.tabDatas.length == 0) {
            return;
        }
        this.tabContents.map(function (content, index) {
            var tab = _this.tabDatas[index];
            if (tab.select) {
                _this.nowSelectTab = tab;
            }
            if (tab.component) {
                var component = _this.resolver.resolveComponentFactory(tab.component);
                _this.ref = content.viewContainerRef.createComponent(component);
                if (tab.data) {
                    var instance = _this.ref.instance;
                    instance.data = tab.data;
                }
            }
            else if (tab.url) {
                // let params = tab.params == null ? {} : tab.params;
                // this.router.navigate([tab.url], { queryParams: params });
            }
        });
        if (this.nowSelectTab == null) {
            this.tabDatas[0].select = true;
        }
        this.changeRef.detectChanges();
    };
    /*  ngOnChanges(changes: SimpleChanges) {
        if (changes.tabDatas && !changes.tabDatas.firstChange) {
          this.init();
        }
      }*/
    TabComponent.prototype.changeTab = function (tab) {
        for (var _i = 0, _a = this.tabDatas; _i < _a.length; _i++) {
            var d = _a[_i];
            d.select = false;
        }
        tab.select = true;
        this.nowSelectTab = tab;
        // this.init();
        this.tabChangeEvent.emit(tab);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TabComponent.prototype, "tabDatas", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TabComponent.prototype, "tabChangeEvent", void 0);
    __decorate([
        core_1.ViewChildren(tab_directive_1.TabContentDirective),
        __metadata("design:type", core_1.QueryList)
    ], TabComponent.prototype, "tabContents", void 0);
    TabComponent = __decorate([
        core_1.Component({
            selector: 'dc-tab',
            template: "\n  <div class=\"display-flex width-100 flex-direction-column\">\n    <div class=\"display-flex width-100 tabs\">\n        <div *ngFor=\"let d of tabDatas\">\n            <div class=\"title\" (click)=\"changeTab(d)\" [ngClass]=\"{'active':d.select}\">\n                <div *ngIf=\"d.icon\" class=\"icon\"><img src=\"{{d.icon}}\"></div>\n                <div>{{d.title}}</div>\n                <i *ngIf=\"d.notify && d.notify>0\" [ngStyle]=\"{'background-color':d.notifyColor}\">{{d.notify}}</i>\n            </div>\n        </div>\n    </div>\n    <div *ngFor=\"let c of tabDatas\" [hidden]=\"!c.select\">\n      <span dcTabContentHost></span>\n    </div>\n  </div>",
            styles: [
                ".tabs {\n      padding: 15px 20px 0;\n      border-bottom: solid 1px #d6d6d6\n    }\n    \n    .tabs>div {\n      margin-right: 70px\n    }\n    \n    .title {\n      cursor: pointer;\n      display: table;\n      position: relative;\n      bottom: 0;\n      font-size: 18px;\n      height: 36px;\n      color: #666;\n    }\n    \n    .title.active {\n      font-weight: bold;\n      color: #333;\n      border-bottom: solid 2px #333;\n      bottom: -1px;\n    }\n    \n    .title>div {\n      display: table-cell;\n      vertical-align: middle;\n    }\n    \n    .title.active>div {\n      padding-bottom: 3px\n    }\n    \n    .title>div.icon {\n      padding: 0 10px 5px 0\n    }\n    \n    .title>i {\n      font-size: 10px;\n      font-weight: 400;\n      position: absolute;\n      left: calc(100% + 7px);\n      top: 10px;\n      display: block;\n      padding: 0 8px;\n      line-height: 14px;\n      height: 16px;\n      color: #fff;\n      border-radius: 10px;\n      font-style: normal\n    }\n    \n    .title.active>i {\n        top: 9px\n    }"
            ],
            changeDetection: core_1.ChangeDetectionStrategy.OnPush
        }),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver, router_1.Router,
            core_1.ChangeDetectorRef])
    ], TabComponent);
    return TabComponent;
}());
exports.TabComponent = TabComponent;
//# sourceMappingURL=tab.component.js.map