"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
var TableComponent = /** @class */ (function () {
    function TableComponent(renderer) {
        this.renderer = renderer;
        this.checkBox = false;
        this.sortEvent = new core_1.EventEmitter();
        this.checkEvent = new core_1.EventEmitter();
        this.nowSort = {};
        this.allSelect = false;
        this.checks = [];
        this.checks_data = [];
        this.scrollBarWidth = 0;
        this.showFilter = [];
    }
    Object.defineProperty(TableComponent.prototype, "datas", {
        get: function () {
            return this._datas;
        },
        set: function (v) {
            this.allSelect = false;
            this._datas = v;
            this.initCheck();
        },
        enumerable: true,
        configurable: true
    });
    /*
      ngOnChanges(changes: SimpleChanges): void {
        if (changes.datas && !changes.datas.firstChange) {
          this.allSelect = false;
          this.datas = changes.datas.currentValue;
          this.initCheck();
        }
      }*/
    TableComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.setDivWidth();
        this.resizeEvent = rxjs_1.Observable.fromEvent(window, 'resize').subscribe(function (event) {
            _this.setDivWidth();
        });
        // this.initCheck();
    };
    TableComponent.prototype.ngOnDestroy = function () {
        this.resizeEvent.unsubscribe();
    };
    TableComponent.prototype.setWidth = function (width) {
        if (width && width.indexOf('%') > 0) {
            return parseInt(width) / 100 * this.initWidth + 'px';
        }
        else {
            return width;
        }
    };
    TableComponent.prototype.setDivWidth = function () {
        var parent = this.tableContainer.nativeElement.parentNode.parentNode;
        this.initWidth = parent.offsetWidth;
        if (this.scrollHeight) {
            this.renderer.setElementStyle(this.overflowBox.nativeElement, 'width', this.initWidth + 'px');
        }
    };
    TableComponent.prototype.initCheck = function () {
        this.checks = [];
        for (var _i = 0, _a = this.datas; _i < _a.length; _i++) {
            var d = _a[_i];
            this.checks.push(false);
        }
    };
    TableComponent.prototype.allSelectCheck = function () {
        this.checks = [];
        for (var _i = 0, _a = this.datas; _i < _a.length; _i++) {
            var d = _a[_i];
            this.checks.push(this.allSelect);
        }
        this.sendCheckEvent();
    };
    TableComponent.prototype.checkSelect = function () {
        var allTrue = true;
        for (var _i = 0, _a = this.checks; _i < _a.length; _i++) {
            var c = _a[_i];
            if (!c) {
                allTrue = false;
            }
        }
        if (allTrue) {
            this.allSelect = true;
        }
        else {
            this.allSelect = false;
        }
        this.sendCheckEvent();
    };
    TableComponent.prototype.checkOption = function (event, k, header) {
        header.filter.optionList[k].check = event;
    };
    TableComponent.prototype.sendCheckOption = function (header) {
        var result = header.filter.optionList.filter(function (item) { return item.check; });
        header.filter.fn(result);
    };
    TableComponent.prototype.sendCheckEvent = function () {
        this.checks_data = [];
        for (var i = 0; i < this.datas.length; i++) {
            if (this.checks[i]) {
                this.checks_data.push(this.datas[i]);
            }
        }
        this.checkEvent.emit(this.checks_data);
    };
    TableComponent.prototype.sort = function (header) {
        var _this = this;
        if (!header.canSort) {
            return;
        }
        if (this.nowSort.field == header.field) {
            if (this.nowSort.sort == 'asc') {
                this.nowSort.sort = 'desc';
            }
            else {
                this.nowSort.sort = 'asc';
            }
        }
        else {
            this.nowSort.field = header.field;
            this.nowSort.sort = 'desc';
        }
        if (this.sortEvent.observers.length) {
            this.sortEvent.emit(this.nowSort);
        }
        else {
            this.datas.sort(function (a, b) {
                var result = _this.nowSort.sort === 'asc' ? a[_this.nowSort.field] > b[_this.nowSort.field] : b[_this.nowSort.field] > a[_this.nowSort.field];
                return result ? 1 : 0;
            });
        }
    };
    TableComponent.prototype.showFilterBox = function (event, header) {
        this.hideFilter();
        event.stopPropagation();
        event.preventDefault();
        var filterBoxDom = event.target.nextElementSibling;
        filterBoxDom.style.display = 'block';
        var flag = false;
        for (var i = 0; i < this.showFilter.length; i++) {
            if (this.showFilter[i] == filterBoxDom) {
                flag = true;
                break;
            }
        }
        if (!flag) {
            this.showFilter.push(filterBoxDom);
        }
        this.currentField = header.field;
    };
    TableComponent.prototype.hideFilter = function () {
        for (var i = 0; i < this.showFilter.length; i++) {
            this.showFilter[i].style.display = 'none';
        }
        this.showFilter = [];
    };
    TableComponent.prototype.clickFilter = function (event, header) {
        header.filter.fn(event.target.value);
        var filterBoxDom = event.target.parentNode;
        filterBoxDom.style.display = 'none';
    };
    TableComponent.prototype.onDocumentClick = function ($event) {
        var current = $event.target;
        for (var i = 0; i < this.showFilter.length; i++) {
            if (current.parentNode !== this.showFilter[i] && current !== this.showFilter[i].prevElementSibling && current !== this.showFilter[i])
                this.showFilter[i].style.display = 'none';
        }
    };
    __decorate([
        core_1.ContentChild(core_1.TemplateRef),
        __metadata("design:type", core_1.TemplateRef)
    ], TableComponent.prototype, "template", void 0);
    __decorate([
        core_1.ViewChild('filterTemplate'),
        __metadata("design:type", Object)
    ], TableComponent.prototype, "filterTemplate", void 0);
    __decorate([
        core_1.ViewChild('table'),
        __metadata("design:type", core_1.ElementRef)
    ], TableComponent.prototype, "tableContainer", void 0);
    __decorate([
        core_1.ViewChild('overflowBox'),
        __metadata("design:type", core_1.ElementRef)
    ], TableComponent.prototype, "overflowBox", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], TableComponent.prototype, "headers", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TableComponent.prototype, "datas", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], TableComponent.prototype, "checkBox", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TableComponent.prototype, "sortEvent", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TableComponent.prototype, "checkEvent", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], TableComponent.prototype, "scrollHeight", void 0);
    __decorate([
        core_1.HostListener('document:click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], TableComponent.prototype, "onDocumentClick", null);
    TableComponent = __decorate([
        core_1.Component({
            selector: 'dc-table',
            template: "<table class=\"table\" #table>\n      <thead>\n        <tr>\n          <th *ngIf=\"checkBox\">\n            <input type='checkbox' [(ngModel)]='allSelect' (ngModelChange)=\"allSelectCheck()\">\n          </th>\n          <th class=\"table-title\" [style.width]=\"setWidth(header.width)\" *ngFor=\"let header of headers let j = index\" title=\"{{header.title}}\">\n            <div class=\"table-title-th\">\n              <div [ngStyle]=\"{'border-left':j===0?'none':'solid 1px #ccc'}\" class=\"text-over-flow\">{{header.title}}</div>\n              <div *ngIf=\"header.filter\" class=\"table-th-filter\">\n                <div class=\"filterBtn\" (click)=\"showFilterBox($event, header)\"></div>\n                <ng-container [ngTemplateOutlet]=\"filterTemplate\" [ngTemplateOutletContext]=\"{$implicit: header}\"></ng-container>\n              </div>\n              <div *ngIf=\"header.canSort\" class=\"table-th-sort\" (click)=\"sort(header)\" [ngClass]=\"{'asc':nowSort.field==header.field && nowSort.sort=='asc','desc':nowSort.field==header.field && nowSort.sort=='desc'}\">\n              </div>\n            </div>\n          </th>\n        </tr>\n      </thead>\n      <div [style.height]=\"scrollHeight || 'auto'\" #overflowBox>\n      <tbody>\n        <tr *ngFor=\"let data of datas; let i = index\">\n          <td *ngIf=\"checkBox\">\n            <input type='checkbox' [(ngModel)]='checks[i]' (ngModelChange)=\"checkSelect()\">\n          </td>\n          <td *ngFor=\"let header of headers\">\n            <ng-container [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"{$implicit: {d: data, h: header, w: setWidth(header.width)}}\"></ng-container>\n          </td>\n        </tr>\n      </tbody>\n      </div>\n    </table>\n\n    <ng-template #filterTemplate let-header>\n      <div *ngIf=\"header.filter.type === 'text'\" class=\"filter-box\">\n        <input type=\"text\" value=\"\" (keyup.enter)=\"clickFilter($event, header)\" placeholder=\"\u8BF7\u8F93\u5165\u7B5B\u9009\u5185\u5BB9\">\n      </div>\n      <div *ngIf=\"header.filter.type === 'checkList'\" class=\"filter-box\">\n        <ng-container *ngFor=\"let option of header.filter.optionList; let k = index\">\n          <input type='checkbox' [(ngModel)]='option.check' (ngModelChange)=\"checkOption($event, k, header)\">\n          <span>{{option.name}}</span>\n          <br/>\n        </ng-container>\n        <div>\n          <div class=\"filterSubmit\" (click)=\"sendCheckOption(header)\">\u786E\u5B9A</div>\n        </div>\n      </div>\n    </ng-template>",
            styles: [
                ".canSort {\n      cursor: pointer\n    }\n    \n    .table-title {\n      font-size: 14px;\n    }\n    \n    table {\n      border: none;\n    }\n\n    table thead, table tbody {\n      display: unset;\n    }\n\n    table>div {\n      display: block;\n      overflow-x: hidden;\n      overflow-y: auto;\n    }\n    \n    table th {\n      color: #333;\n      background-color: #fff;\n      border-bottom: 1px solid #cccccc;\n    }\n    \n    table td {\n      border-bottom: 1px solid #e2e2e2;\n      border-top: none;\n    }\n    \n    .sort {\n      background-image: url(/assets/img/sort.png);\n      background-repeat: no-repeat;\n      background-position: center;\n      width: 20px;\n      height: 13px;\n      display: inline-block;\n    }\n    \n    .sort-desc {\n      background-image: url(/assets/img/sort.png);\n      background-repeat: no-repeat;\n      background-position: center;\n      width: 20px;\n      height: 13px;\n      transform: rotate(180deg);\n    }\n    \n    .table-title-th {\n      display: flex;\n    }\n    \n    .table-title-th>div {\n      display: inline-block;\n      margin-right: 5px\n    }\n    \n    .table {\n      font-size: 12px;\n      color: #666 !important;\n    }\n    \n    .table th {\n      font-size: 14px;\n      color: #333 !important;\n      line-height: 13px;\n    }\n    \n    .table-th-sort {\n      position: relative;\n      background: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAgAAAAMBAMAAACtsOGuAAAAHlBMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmbpCqcMAAAACXRSTlMA5sZkORkGnJnb+QAcAAAAMElEQVQI12NgYDZgYGDwnMLAwCo5MYAhaeZMNYbOmTNnMCBA5cyZ08ESYCVgxWBtAGv8DCictG4/AAAAAElFTkSuQmCC') no-repeat left center;\n      width: 8px;\n      height: 12px;\n      top: 1px;\n      cursor: pointer;\n    }\n    \n    .table-th-sort.asc {\n      background: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAgAAAAFBAMAAACKv7BmAAAAG1BMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZ8aTmeAAAACHRSTlMA5MaZYzkYBjL+0/MAAAAhSURBVAjXY2BgcWBgYIhoZWBgk2hMYCjq6FBnsOjoaAYAMaEFlaDQ04sAAAAASUVORK5CYII=') no-repeat left top;\n    }\n    \n    .table-th-sort.desc {\n      background: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAgAAAAFBAMAAACKv7BmAAAAG1BMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZ8aTmeAAAACHRSTlMA58acZjkbBtcF5e8AAAAhSURBVAjXY7Do6GhmKOroUGdgk2hMYGCIaGVgYGBxYAAAWCUFlY5P/qEAAAAASUVORK5CYII=') no-repeat left bottom;\n    }\n    \n    .table-th-filter {\n      position: relative;\n      background: url('data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAA0AAAAOBAMAAAAGUYvhAAAAKlBMVEUAAABmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZmZY/DOeAAAADXRSTlMA7hHexqWBXTwhA65Xbt8TvwAAAEBJREFUCNdjiL0LAgEMyiDqsgIDB4i+wcDAkAukE4D0krt3rywA0pyydyUZQKD2bgGY5r3LgJfmkWWAAG0GBAAA/oQb9Q1/UEkAAAAASUVORK5CYII=') no-repeat left bottom;\n      width: 13px;\n      height: 14px;\n      top: 1px;\n      font-size: 12px;\n      color: #666;\n      font-weight: normal\n    }\n    \n    .filterBtn {\n      width: 100%;\n      height: 100%;\n      display: block;\n      cursor: pointer;\n    }\n    \n    .filter-box {\n      position: absolute;\n      left: -100%;\n      top: 20px;\n      display: none;\n      background: #fff;\n      padding: 5px;\n      box-shadow: 0px 0px 2px 1px #ccc;\n      text-indent: 0;\n      border-radius: 2px\n    }\n    \n    .filter-box>input[type=text] {\n      width: 159px;\n      height: 26px;\n      border: solid 1px #ccc;\n      padding: 0;\n      margin: 0;\n      background: #fff;\n      transition: none;\n      text-indent: 5px;\n      font-size: 14px;\n      font-weight: normal;\n      color: #666;\n      border-radius: 2px;  \n      font-size: 12px\n    }\n    \n    .filter-box>input:focus {\n      border-color: #0081cc\n    }\n    \n    .filter-box>input[type=checkbox], .filter-box>span {\n      display: inline-block;\n      font-size: 14px;\n      line-height: 25px;\n      text-indent: 7px\n    }\n    \n    .filter-box>input[type=checkbox] {\n      position: relative;\n      left: 5px;\n      bottom: -2px;\n      cursor: pointer;\n    }\n    \n    .filterSubmit {  \n      padding: 0 20px;\n      text-align: center;\n      margin: 5px auto;\n      color: #fff;\n      width: 94px;\n      height: 26px;\n      line-height: 23px;  \n      font-size: 14px;\n      background: #0081cc;\n      border-radius: 10px;\n      box-shadow: 0px 0px 1px 1px #ccc;\n      cursor: pointer;\n    }\n    \n    .filterSubmit:hover {\n      background: #0067a3\n    }\n    \n    .filterSubmit:active {\n      box-shadow: none\n    }\n    \n    .table th,\n    .table td {\n      text-align: left;\n      border-top: none;\n      padding: 20px 0 15px;\n      text-indent: 20px;\n      height: 14px;\n      line-height: 14px\n    }"
            ]
        }),
        __metadata("design:paramtypes", [core_1.Renderer])
    ], TableComponent);
    return TableComponent;
}());
exports.TableComponent = TableComponent;
//# sourceMappingURL=table.component.js.map