"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var NodeComponent = /** @class */ (function () {
    function NodeComponent(resolver, router) {
        this.resolver = resolver;
        this.router = router;
        this.clickEvent = new core_1.EventEmitter();
        this.extendEvent = new core_1.EventEmitter();
        this.nodeChangeEvent = new core_1.EventEmitter();
    }
    Object.defineProperty(NodeComponent.prototype, "nodeData", {
        get: function () {
            return this._nodeData;
        },
        set: function (v) {
            this._nodeData = v;
            this.init();
        },
        enumerable: true,
        configurable: true
    });
    NodeComponent.prototype.init = function () {
        if (this.needShow(this.nodeData)) {
            this.nodeData.show = true;
        }
    };
    NodeComponent.prototype.needShow = function (node) {
        if (node.show) {
            return true;
        }
        if (node.subNode == null || node.subNode.length == 0) {
            return false;
        }
        var result = false;
        for (var _i = 0, _a = node.subNode; _i < _a.length; _i++) {
            var n = _a[_i];
            if (this.needShow(n)) {
                result = true;
            }
        }
        return result;
    };
    NodeComponent.prototype.ngOnInit = function () {
        this.initClsObj();
    };
    NodeComponent.prototype.initClsObj = function () {
        if (this.options && this.options.iconCls) {
            this.iconClsFolder = this.options.iconCls.folder;
            this.iconClsFile = this.options.iconCls.file;
            this.iconClsExpand = this.options.iconCls.expand;
        }
    };
    NodeComponent.prototype.getFileIcon = function () {
        if (this.iconClsFile && (!this.nodeData[this.keyChild] || this.nodeData[this.keyChild].length == 0)) {
            return this.iconClsFile;
        }
        return '';
    };
    NodeComponent.prototype.getFolderIcon = function () {
        if (this.iconClsFolder && this.nodeData[this.keyChild] && this.nodeData[this.keyChild].length > 0) {
            return this.iconClsFolder;
        }
        return '';
    };
    NodeComponent.prototype.getExpandIcon = function () {
        if (this.iconClsExpand && this.nodeData.show) {
            return this.iconClsExpand;
        }
        return '';
    };
    NodeComponent.prototype.clickNode = function (nodeData) {
        this.clickEvent.emit(this.nodeData);
    };
    NodeComponent.prototype.changeShow = function () {
        this.nodeData.show = !this.nodeData.show;
        this.extendEvent.emit(this.nodeData);
    };
    NodeComponent.prototype.doNodeFn = function (option) {
        if (option.fn) {
            option.fn(this.nodeData);
        }
    };
    NodeComponent.prototype._clickNode = function (event) {
        this.clickEvent.emit(event);
    };
    NodeComponent.prototype._extendNode = function (event) {
        this.extendEvent.emit(event);
    };
    NodeComponent.prototype.ngOnChanges = function (changes) {
    };
    NodeComponent.prototype.getText = function () {
        if (this._nodeData.show) {
            return '-';
        }
        else {
            return '+';
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], NodeComponent.prototype, "root", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], NodeComponent.prototype, "keyId", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], NodeComponent.prototype, "keyName", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", String)
    ], NodeComponent.prototype, "keyChild", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], NodeComponent.prototype, "options", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], NodeComponent.prototype, "clickEvent", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], NodeComponent.prototype, "extendEvent", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], NodeComponent.prototype, "nodeData", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], NodeComponent.prototype, "nodeChangeEvent", void 0);
    NodeComponent = __decorate([
        core_1.Component({
            selector: 'dc-node',
            template: "\n  <div class=\"display-flex width-100 flex-direction-column node-container\">\n  <div class=\"display-flex width-100\">\n    <div class=\"before-node\">\n    </div>\n    <div class=\"icon\" [class.cursor-pointer]=\"nodeData[keyChild]!=null && nodeData[keyChild].length>0\">\n      <i (click)=\"changeShow()\" *ngIf=\"nodeData[keyChild]!=null && nodeData[keyChild].length>0\">{{getText()}}</i>\n    </div>\n    <div class=\"tree-icon\" *ngIf=\"options && options['iconCls']\" [ngClass]=\"[getFileIcon(),getFolderIcon(),getExpandIcon()]\">\n    </div>\n    <div class=\"cursor-pointer\" (click)=\"clickNode(nodeData)\"\n         [class.active]=\"nodeData.lighthight\" [class.selected]=\"nodeData.selected\">\n      {{nodeData[keyName]}}\n    </div>\n    <div class=\"\" *ngIf=\"options && options.actionBtn\" style=\"float: right;\">\n      <ng-template ngFor let-actbtn [ngForOf]=\"options.actionBtn\">\n        <i *ngIf=\"(root && !actbtn.rootHide) || !root\" class=\"{{actbtn.cls}}\"\n           (click)=\"doNodeFn(actbtn)\">{{actbtn.text}}</i>\n      </ng-template>\n    </div>\n  </div>\n\n  <div *ngIf=\"nodeData[keyChild]!=null && nodeData[keyChild].length>0 && nodeData.show\"\n       class=\"display-flex width-100 flex-direction-column sub-node-container\">\n    <div *ngFor=\"let node of nodeData[keyChild]\">\n      <div>\n        <dc-node [nodeData]=\"node\" [keyChild]=\"keyChild\" [keyId]=\"keyId\"\n                 [options]=\"options\" [keyName]=\"keyName\"\n                 (clickEvent)=\"_clickNode($event)\" (extendEvent)=\"_extendNode($event)\"></dc-node>\n      </div>\n    </div>\n  </div>\n</div>\n  ",
            styles: [
                '.sub-node-container{margin-left: 10px;}',
                '.before-node{}',
                '.left-line{position: absolute;width: 1px;height: 100000px;border-left: 1px solid red;}',
                '.node-container{overflow: hidden;position: relative;};',
                '.icon{width: 10px;}',
                '.noIcon{margin-left: 10px;}',
                '.tree-icon{display: inline-block;width: 20px;height: 20px;}'
            ]
        }),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver, router_1.Router])
    ], NodeComponent);
    return NodeComponent;
}());
exports.NodeComponent = NodeComponent;
//# sourceMappingURL=node.component.js.map