"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var TreeComponent = /** @class */ (function () {
    function TreeComponent(resolver, router) {
        this.resolver = resolver;
        this.router = router;
        this.clickEvent = new core_1.EventEmitter();
        this.extendEvent = new core_1.EventEmitter();
        this.tempSearch = [];
    }
    Object.defineProperty(TreeComponent.prototype, "treeDatas", {
        get: function () {
            return this._treeDatas;
        },
        set: function (v) {
            this._treeDatas = v;
        },
        enumerable: true,
        configurable: true
    });
    TreeComponent.prototype.ngOnInit = function () {
        if (!this.keyId) {
            this.keyId = 'id';
        }
        if (!this.keyName) {
            this.keyName = 'title';
        }
        if (!this.keyChild) {
            this.keyChild = 'subNode';
        }
    };
    TreeComponent.prototype.clickNode = function (event) {
        this.clickEvent.emit(event);
    };
    TreeComponent.prototype.extendNode = function (event) {
        this.extendEvent.emit(event);
    };
    TreeComponent.prototype._findNodeById = function (id, source) {
        for (var i = 0; i < source.length; i++) {
            var theI = source[i];
            if (theI[this.keyId] == id) {
                return theI;
            }
            if (theI[this.keyChild]) {
                var res = this._findNodeById(id, theI[this.keyChild]);
                if (res) {
                    return res;
                }
            }
        }
    };
    TreeComponent.prototype._findNodeByAllName = function (name, source) {
        for (var i = 0; i < source.length; i++) {
            var theI = source[i];
            if (theI[this.keyName] == name) {
                this.tempSearch.push(theI);
            }
            if (theI[this.keyChild]) {
                this._findNodeByAllName(name, theI[this.keyChild]);
            }
        }
    };
    TreeComponent.prototype._findNodeByName = function (name, source) {
        for (var i = 0; i < source.length; i++) {
            var theI = source[i];
            if (theI[this.keyName].toLowerCase().indexOf(name.toLowerCase()) != -1) {
                this.tempSearch.push(theI);
            }
            if (theI[this.keyChild]) {
                this._findNodeByName(name, theI[this.keyChild]);
            }
        }
    };
    TreeComponent.prototype._findParentNodeById = function (id, source, parent) {
        for (var i = 0; i < source.length; i++) {
            var theI = source[i];
            if (theI[this.keyId] == id) {
                return parent;
            }
            if (theI[this.keyChild]) {
                var res = this._findParentNodeById(id, theI[this.keyChild], theI);
                if (res) {
                    return res;
                }
            }
        }
    };
    TreeComponent.prototype._findParentsNodeById = function (result, id, source) {
        for (var i = 0; i < source.length; i++) {
            var theI = source[i];
            if (theI[this.keyId] == id) {
                result.push(theI);
                return theI;
            }
            if (theI[this.keyChild]) {
                var res = this._findParentsNodeById(result, id, theI[this.keyChild]);
                if (res) {
                    result.push(theI);
                    return res;
                }
            }
        }
    };
    TreeComponent.prototype._findChildrensNodeByNode = function (result, source) {
        result.push(source);
        if (source[this.keyChild]) {
            for (var i = 0; i < source[this.keyChild].length; i++) {
                this._findChildrensNodeByNode(result, source[this.keyChild][i]);
            }
        }
    };
    // 匹配搜索
    TreeComponent.prototype._matchSearchNodesByKey = function (result, val, key, source) {
        for (var i = 0; i < source.length; i++) {
            var theI = source[i];
            if (theI[key] == val) {
                result.push(source[i]);
            }
            if (theI[this.keyChild]) {
                this._matchSearchNodesByKey(result, val, key, theI[this.keyChild]);
            }
        }
    };
    // 模糊搜索
    TreeComponent.prototype._fuzzySearchNodesByKey = function (result, val, key, source) {
        for (var i = 0; i < source.length; i++) {
            var theI = source[i];
            if (theI[key].toLowerCase().indexOf(val.toLowerCase()) != -1) {
                result.push(source[i]);
            }
            if (theI[this.keyChild]) {
                this._fuzzySearchNodesByKey(result, val, key, theI[this.keyChild]);
            }
        }
    };
    // 根据ID查询节点
    TreeComponent.prototype.findNodeById = function (id) {
        this.tempSearch = [];
        return this._findNodeById(id, this.treeDatas);
    };
    // 根据名称查询全匹配节点
    TreeComponent.prototype.findNodeByName = function (name) {
        this.tempSearch = [];
        this._findNodeByName(name, this.treeDatas);
        return this.tempSearch;
    };
    // 根据名称模糊查询节点
    TreeComponent.prototype.findNodeByAllName = function (name) {
        this.tempSearch = [];
        this._findNodeByAllName(name, this.treeDatas);
        return this.tempSearch;
    };
    // 获取父节点
    TreeComponent.prototype.findParentNodeById = function (id) {
        return this._findParentNodeById(id, this.treeDatas);
    };
    //获取父节点链
    TreeComponent.prototype.findParentsNodeById = function (id) {
        var result = [];
        this._findParentsNodeById(result, id, this.treeDatas);
        return result;
    };
    TreeComponent.prototype.findChildrensNodeByNode = function (node) {
        var result = [];
        this._findChildrensNodeByNode(result, node);
        return result;
    };
    // 插入节点
    TreeComponent.prototype.insertNode = function (child, parent) {
        var targetData;
        var parents;
        if (parent) {
            parents = this.findParentsNodeById(parent[this.keyId]);
            if (parents && parents.length > 0) {
                if (!parents[0][this.keyChild]) {
                    parents[0][this.keyChild] = [];
                }
                targetData = parents[0][this.keyChild];
                for (var i = 0; i < parents.length; i++) {
                    parents[i].show = true;
                }
            }
        }
        else {
            targetData = this.treeDatas;
        }
        targetData.push(child);
        return child;
    };
    //更新节点数据
    TreeComponent.prototype.updateNodeData = function (data, keys) {
        if (!keys) {
            return;
        }
        var targetNode = this.findNodeById(data[this.keyId]);
        for (var i = 0; i < keys.length; i++) {
            targetNode[keys] = data[keys];
        }
    };
    //删除节点
    TreeComponent.prototype.deleteNodeById = function (id) {
        var parentNode = this.findParentNodeById(id);
        if (!parentNode) {
            parentNode = this.treeDatas;
        }
        else {
            parentNode = parentNode[this.keyChild];
        }
        for (var i = 0; i < parentNode.length; i++) {
            if (parentNode[i][this.keyId] == id) {
                parentNode.splice(i, 1);
                break;
            }
        }
    };
    // 匹配搜索
    TreeComponent.prototype.matchSearchNodesByKey = function (val, key) {
        var result = [];
        this._matchSearchNodesByKey(result, val, key, this.treeDatas);
        return result;
    };
    // 模糊搜索
    TreeComponent.prototype.fuzzySearchNodesByKey = function (val, key) {
        var result = [];
        this._fuzzySearchNodesByKey(result, val, key, this.treeDatas);
        return result;
    };
    //展开节点
    TreeComponent.prototype.expandNode = function (node) {
        var parents = this.findParentsNodeById(node[this.keyId]);
        if (parents && parents.length > 0) {
            if (!parents[0][this.keyChild]) {
                parents[0][this.keyChild] = [];
            }
            for (var i = 0; i < parents.length; i++) {
                parents[i].show = true;
            }
        }
    };
    // 展开节点s
    TreeComponent.prototype.expandNodes = function (nodes) {
        for (var i = 0; i < nodes.length; i++) {
            this.expandNode(nodes[i]);
        }
    };
    // 高亮节点s
    TreeComponent.prototype.lighthightNodes = function (nodes) {
        for (var i = 0; i < nodes.length; i++) {
            nodes[i].lighthight = true;
        }
    };
    // 移除高亮s
    TreeComponent.prototype.removeLighthightNodes = function (nodes) {
        for (var i = 0; i < nodes.length; i++) {
            delete nodes[i].lighthight;
        }
    };
    // 选中节点
    TreeComponent.prototype.selectTreeNode = function (node) {
        this.selectedNode && this.deSelectTreeNode(this.selectedNode);
        var item = this.findNodeById(node[this.keyId]);
        if (item) {
            item.selected = true;
            this.selectedNode = item;
        }
    };
    // 移除选中
    TreeComponent.prototype.deSelectTreeNode = function (node) {
        var item = this.findNodeById(node[this.keyId]);
        if (item) {
            delete item.selected;
        }
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TreeComponent.prototype, "clickEvent", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TreeComponent.prototype, "extendEvent", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], TreeComponent.prototype, "options", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TreeComponent.prototype, "treeDatas", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], TreeComponent.prototype, "keyId", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], TreeComponent.prototype, "keyName", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object)
    ], TreeComponent.prototype, "keyChild", void 0);
    TreeComponent = __decorate([
        core_1.Component({
            selector: 'dc-tree',
            template: "\n  <div class=\"display-flex width-100 flex-direction-column\">\n    <div *ngFor=\"let node of treeDatas\">\n        <div class=\"node-container\">\n            <dc-node [nodeData]=\"node\" [root]=\"true\" [keyChild]=\"keyChild\" [keyId]=\"keyId\" [keyName]=\"keyName\" [options]=\"options\"\n            (clickEvent)=\"clickNode($event)\" (extendEvent)=\"extendNode($event)\"></dc-node>\n        </div>\n    </div>\n</div>\n\n  ",
            styles: [
                'tree-node-container {overflow: hidden;position: relative;}'
            ]
        }),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver, router_1.Router])
    ], TreeComponent);
    return TreeComponent;
}());
exports.TreeComponent = TreeComponent;
//# sourceMappingURL=tree.component.js.map